Function loadmap(path$)
	;Rckstnde von eventuell schon geffneten
	;Maps entfernen
	For w.waypoint = Each waypoint
		FreeEntity w\piv
		Delete  w
	Next
	For c.car = Each car
		FreeEntity c\mesh
		FreeEntity c\lastwaypoint
		Delete c
	Next
	pivnr = 0
	;Lesezugriff auf die Map starten
	in = ReadFile(path$)
	While Not Eof(in)	;Solange das Ende der Datei
						;noch nicht erreicht wurde,
						;wird weiter gelesen.
		rl$ = ReadLine(in)	;Hier wird eine Zeile aus
							;der Datei gelesen, und
							;in einer Variable zur
							;Weiterverarbeitung gespeichert.
		If Left(rl$, 8) = "mapname="	;Left gibt von einem String
										;die angegebene Anzahl Zeichen
										;beginnend von Links zurck
										;Wenn also die ersten 8 Zeichen
										;"mapname=" sind, dann wird dieser
										;If-Block ausgelst.
			mapname$ = Mid(rl$, 9)	;Mid gibt von einem String alle Zeichen
									;ab der angegebenen Stelle zurck.
									;In diesem Fall werden alle Zeichen
									;ab Inklusive dem 9. zurck gegeben.
		ElseIf Left(rl$, 5) = "hmap="
			terrain = LoadTerrain(Mid(rl$,6))	;Die in der Mapdatei
												;angegebene Heightmap wird geladen.
		ElseIf Left(rl$, 6) = "track="
			tex2 = LoadTexture(Mid(rl$,7))		;Die in der Mapdatei angegebene
												;Strecke wird als Textur geladen.
		ElseIf Left(rl$, 9) = "tracktex="
			tex3 = LoadTexture(Mid(rl$,10))		;Die in der Mapdatei angegebene
												;Straentextur wird geladen.
		ElseIf Left(rl$, 10) = "groundtex="
			tex1 = LoadTexture(Mid(rl$,11))		;Die in der Mapdatei angegebene
												;Bodentextur wird geladen.
		ElseIf Left(rl$, 9) = "startpos="
			c.car = New car						;Ein neues Auto wird erstellt.
			c\npc = 0							;Diesem wird zugewiesen, dass es kein
												;NPC (=Nicht-Spieler-Charakter) ist.
			c\mesh = LoadMesh("car1.x")			;Das Modell des Wagens wird geladen.
			c\maxspeed = 4.5					;Maximalgeschwindigkeit und
			c\turnfact = 1						;Modifikator fr die Lenkgeschwindigkeit
												;werden festgelegt.
			rl$ = Mid(rl$, 10)					;Zwecks einfacher Weiterverarbeitung
												;werden die nun unntigen 9 linken
												;Zeichen abgeschnitten.
			pos = Instr(rl$, ":")				;Die Position des Doppelpunktes im
												;String wird bestimmt
			c\lastwaypoint = CreatePivot()		;Ein Pivot (=Modell ohne sichtbaren
												;Teilen) wird erstellt. Dieses Modell
												;wird spter bentigt.
			PositionEntity c\mesh, Int(Left(rl$,pos)), 1, 64*50-Int(Mid(rl$,pos+1))
												;Das Modell wird an die in der Mapdatei
												;angegebene Startposition versetzt.
			RotateMesh c\mesh, 0, 180, 0		;Das Modell wird abschlieend noch
			ScaleMesh c\mesh, 5, 5, 5			;gedreht und skaliert fr eine bessere
												;Optik im Spiel.
			EntityType c\mesh, 2				;Dem Modell wird ein Kollisionstyp
												;zugewiesen. Dazu spter mehr.
												
		ElseIf Left(rl$, 7) = "npcpos="			;Siehe oben, mit folgenden Ausnahmen:
			c.car = New car
			c\mesh = LoadMesh("car1.x")
			c\maxspeed = 4+Rnd(-.1, -1)			;Zufallswerte fr Maximalgeschwindigkeit
			c\turnfact = Rnd(.9, 1.1)			;und Lenkgeschwindigkeit werden gesetzt.
												;Dadurch wird dafr gesorgt, dass nicht
												;alle Computergegner genau gleich fahren.
			
			c\npc = 1							;Die KI wird aktiviert. Dieses Auto
												;wird jetzt vom Computer gesteuert.
			rl$ = Mid(rl$, 8)
			pos = Instr(rl$, ":")
			c\lastwaypoint = CreatePivot()
			RotateMesh c\mesh, 0, 180, 0
			ScaleMesh c\mesh, 5, 5, 5
			PositionEntity c\mesh, Int(Left(rl$,pos)), 1, 64*50-Int(Mid(rl$,pos+1))
			EntityType c\mesh, 2
			
		ElseIf Left(rl$, 9) = "waypoint="
			rl$ = Mid(rl$, 10)
			pos = Instr(rl$, ":")
			w.waypoint = New waypoint			;Ein neuer Wegpunkt wird erstellt.
			w\piv = CreatePivot()				;Dazu wird ein Pivot erstellt.
			chp = LoadMesh("checkpoint.x", w\piv);Damit dieser Wegpunkt fr den Spieler
												;sichtbar ist, wird ein Modell geladen
												;und der Pivot als Parent gesetzt.
												;Dadurch befindet sich das Modell auf der
												;Position des Wegpunktes.
			ScaleMesh(chp, 20, 20, 20)			;Dieses Modell wird dann skaliert.
			
			x = Left(rl$,pos)					;Position und Orientierung des
			rl$ = Mid(rl$,pos+1)				;Wegpunktes wird ausgelesen
			pos = Instr(rl$, "!")				;x und z sind die Koordinaten
			z = Left(rl$,pos)					;und dir ist die Ausrichtung.
			dir = Mid(rl$,pos+1)
			
			PositionEntity w\piv, x, -1, 64*50-z;Der Wegpunkt wird an seine Position
			RotateEntity w\piv, 0, dir, 0		;verschoben und richtig gedreht.
			EntityType chp, 1					;Dem Wegpunkt wird ein Kollisionstyp zugewiesen.
			w\nr = pivnr						;Dem Wegpunkt wird eine Nummer zugewiesen und
			pivnr = pivnr+1						;danach der Wegpunktzhler um 1 erhht.
			
		ElseIf Left(rl$, 5) = "laps="
			laps = Int(Mid(rl$, 6))				;Anzahl der zu fahrenden Runden wird gesetzt.
		EndIf
	Wend
	
	ScaleTexture tex2, 64, 64					;Die Spur-Textur wird skaliert, so dass sie die
												;gleiche Gre hat, wie das Terrain.
	TextureBlend tex1, 3						;Die Texturen werden auf Multitexturing gesetzt.
	TextureBlend tex2, 2						;Dadurch werden mehrere Texturen auf einem Modell
	TextureBlend tex3, 2						;mglich. Das hat den Sinn, dass die Strecke eine
												;andere Textur hat, als der Rest.
	TerrainShading terrain, 1					;Das Terrain wird schattiert. Dadurch wirkt der
												;Boden realistischer.
	EntityTexture terrain, tex1, 0, 2			;Das Terrain wird mit den drei Texturen texturiert.
	EntityTexture terrain, tex2, 0, 1			;Die letzte Zahl gibt die Texturebene an. Pro
	EntityTexture terrain, tex3, 0, 0			;Ebene kann nur eine Textur vorhanden sein.
	ScaleEntity terrain, 50, 100, 50			;Das Terrain wird vergrert und
	EntityType terrain, 1						;ihm wird ein Kollisionstyp zugewiesen.
	PositionEntity terrain, 0, -101, 0			;Das Terrain wird nach unten verschoben, so dass sich
												;seine hchste Stelle auf einer Hhe mit der Kamera
End Function									;befindet.
