Graphics3D 800, 600, 16, 2

Type car
	Field mesh, nr, npc, nextwaypoint, lastwaypoint
	Field speed#, maxspeed#, yspeed#
	Field turnfact#, lap
End Type

Type waypoint
	Field piv, nr
End Type

Global terrain, pivnr
Global mapname$, laps

light = CreateLight()
Global cam = CreateCamera()

;Skybox
sky = CreateSphere()
ScaleEntity sky, 5, 5, 5
PositionEntity sky, EntityX(cam), EntityY(cam), EntityZ(cam)
EntityParent sky, cam
EntityTexture sky, LoadTexture("wolken.jpg")
FlipMesh sky
EntityOrder sky, 1
;Ende der Skybox

wassertex = LoadTexture("wasser02.jpg")
ScaleTexture wassertex, 10, 10
Dim water(5)

For i = 1 To 5
	water(i) = CreatePlane()
	PositionEntity water(i), 0, -30*i, 0
	EntityAlpha water(i), .5+.1*i
	EntityTexture water(i), wassertex
Next


Global kipiv = CreatePivot()
Global plchkp = LoadMesh("checkpoint2.x")
ScaleMesh plchkp, 20, 20, 20
EntityColor plchkp, 0, 255, 0


loadmap("test.mp")
game()
WaitKey
End


Function game()
							;Kollisionstypen werden gesetzt:
	Collisions 2, 1, 2, 2	;Spieler-Boden-Kollision
	Collisions 2, 2, 2, 2	;Spieler-Spieler-Kollision
	timer = CreateTimer(60)	;CreateTimer erzeugt eine
							;Spielgeschwindigkeitsbremse, auch genannt FPS-Bremse
							;(FPS = Frames per Second = Bilder die Sekunde).
							;Das hat den Sinn, dass das Spiel sowohl
							;auf langsamen wie schnellen Rechnern gleich
	game=1					;schnell luft.	
	While game=1			;### Hauptschleife ###
		If KeyHit(1) Then End;Bei Drcken der ESC-Taste wird das Spiel beendet.
		pos=0				;Wird bentigt, um die Plazierung des Spielers festzustellen.
		For c.car = Each car
			ecol = EntityCollided(c\mesh, 1)	;Falls der Wagen den Boden berhrt,
												;wird dieser Wert gesetzt.
			;##### Fahrzeugstatus
			If c\lap>=laps Then			;Wenn das Fahrzeug alle bentigten Runden
										;gefahren ist,
				pos = pos+1				;dann wird die ausgegebene Spielerposition
										;um 1 erhht. (Entgltige Spielerposition=
										;Anzahl der schon im Ziel eingetroffenen Wgen+1)
				If c\npc=0 Then game=0	;Wenn der Spieler im Ziel ankommt,
										;beende das Spiel
			EndIf
			If EntityY(c\mesh)<-30 Then	;Wenn der Wagen in das Wasser fllt, dann
				c\speed=c\speed*.97		;verlangsame ihn (Wasser bremst)
				EntityType c\mesh, 0	;und nimm ihm die Kollision (damit die Kamera
										;diesen schnen Schwenk nach unten machen kann)
			EndIf
			If EntityY(c\mesh)<-100 Then;Wenn der Wagen tief genug gefallen ist, dann
				c\speed=0.001			;setze seine Geschwindigkeit auf beinahe Null,
				PositionEntity c\mesh, EntityX(c\lastwaypoint), 2, EntityZ(c\lastwaypoint)
				RotateEntity c\mesh, 0, EntityYaw(c\lastwaypoint), 0
										;setze ihn auf die Position des letzten von ihm
										;durchfahrenen Wegpunktes
				EntityType c\mesh, 2
										;und gib ihm seine Kollision zurck.
			EndIf
			;###### Spielersteuerung
			If c\npc=0 Then			;Falls es sich nicht um einen Computerspieler
									;handelt, wird dieser Block aufgerufen.
				nextplayerwaypoint = c\nextwaypoint
									;Diese Variable wird gesetzt, damit etwas
									;spter im Code der nchste Wegpunkt, den
									;der Spieler anzufahren hat, markiert werden
									;kann.
				If ecol Then		;Wenn der Spieler den Boden nicht berhrt,
									;kann er weder lenken noch beschleunigen oder
									;abbremsen. Darum wird dieser Block nur
									;aufgerufen, falls der Spieler den Boden
									;berhrt.
					If KeyDown(17) Then c\speed = c\speed*.985+c\maxspeed*.015
									;Wenn W gedrckt wird, wird der Wagen
									;beschleunigt.
					If KeyDown(31) Then c\speed = c\speed*.98-c\maxspeed*.02
									;Wenn S gedrckt wird, wird der Wagen
									;abgebremst.
					If KeyDown(30) Then TurnEntity(c\mesh, 0, c\turnfact*3, 0)
									;Wenn A gedrckt wird, wird nach links
									;gelenkt.
					If KeyDown(32) Then TurnEntity(c\mesh, 0, -c\turnfact*3, 0)
									;Wenn D gedrckt wird, wird nach rechts
									;gelenkt.
				EndIf
				camfollow(cam, c\mesh, c\speed)
				;Der Kamera wird befohlen, dem Wagen zu folgen.
			EndIf

			;##### Wegpunkte und KI
			fnd = 0		;Diese Variable sagt aus, ob der nchste
						;anzusteuernde Wegpunkt gefunden wurde.
			If c\npc Then c\speed = c\speed*.985+c\maxspeed*.015
						;Falls es sich um einen KI-Wagen handelt,
						;so soll dieser beschleunigen.
			For w.waypoint = Each waypoint	;Jeder Wegpunkt wird abgefragt,
				If w\nr = c\nextwaypoint And fnd = 0 Then
											;ob einer von ihnen der ist, den der aktive
					fnd=1					;Wagen anfahren soll.
					If c\npc Then	;Wenn der aktive Wagen von der KI gesteuert wird,
									;dann wird dieser Block betreten.
						PositionEntity kipiv, EntityX(c\mesh), EntityY(c\mesh), EntityZ(c\mesh)
						PointEntity kipiv, w\piv
						kiyaw = EntityYaw(kipiv) Mod 360 - EntityYaw(c\mesh) Mod 360
						If kiyaw>180 Then kiyaw = kiyaw-360
											;Der Winkel von Wagen zu dem nchsten
											;Waypoint wird ausgerechnet und je nach dem,
						If kiyaw>0 Then		;ob dieser positiv oder negativ ist,
							TurnEntity(c\mesh, 0, c\turnfact*3, 0) ;wird entweder nach rechts
						Else
							TurnEntity(c\mesh, 0, -c\turnfact*3, 0);oder nach links gelenkt.
						EndIf
					EndIf
					If EntityDistance(c\mesh, w\piv)<20 Then ;Falls der aktive Wagen sich
											;seinem nchsten Waypoint auf 20 Meter nhert
											;(was er normalerweise nur tut, wenn er ihn
											;durchfhrt) dann wird dieser Block aktiv.
						PositionEntity c\lastwaypoint, EntityX(w\piv), 1, EntityZ(w\piv)
						RotateEntity c\lastwaypoint, 0, EntityYaw(w\piv), 0
											;Die Position und Ausrichtung dieses Waypoints
											;wird gespeichert. (Wichtig fr das Zurcksetzen
											;des Wagens, falls er ins Wasser fllt.)
						c\nextwaypoint=c\nextwaypoint+1
											;Dem Wagen wird befohlen, den nchsten Waypoint
											;abzufahren.
						Exit
					EndIf
				EndIf
			Next
			If fnd=0 Then
				c\nextwaypoint = 0;Falls es keinen Waypoint mit
											;der Nummer gibt, die der Wagen als nchsten
											;Waypoint gespeichert hat, dann ist dem so,
											;weil er schon alle Waypoints abgefahren hat.
											;Also soll er wieder bei Waypoint 0 anfangen und
				c\lap = c\lap+1				;ist eine Runde weiter.
			EndIf
			
			;##### Fahrphysik
			ecol2 = EntityCollided(c\mesh, 2)	;Diese Variable wird gesetzt,
												;falls ein Wagen einen anderen
												;berhrt.
			If ecol2 Then
				PositionEntity kipiv, EntityX(c\mesh), EntityY(c\mesh), EntityZ(c\mesh)
				PointEntity kipiv, ecol2
				dir = Abs(EntityYaw(ecol2)-EntityYaw(c\mesh))
												;Der Winkel zwischen dem aktiven
												;Wagen und dem anderen wird gemessen,
												;um herraus zu finden, wer wen
												;angefahren hat.
				If dir < 30 And c\speed>.1 Then c\speed=.1
												;Der Anfahrende wird stark abgebremst.
			EndIf
			If ecol Then c\yspeed#=c\yspeed#/3	;Falls das Fahrzeug den Boden berhrt,
												;wird dessen Fallgeschwindigkeit
												;verringert
			c\yspeed#=c\yspeed#-.05				;Die Fallgeschwindigkeit des Wagens
												;wird um die Gravitation erhht.
			MoveEntity c\mesh, 0, c\yspeed, c\speed	;der Wagen wird um seine
												;Fahr- und Fallgeschwindigkeiten
												;verschoben.
		Next
	For w.waypoint = Each waypoint
	If w\nr = nextplayerwaypoint Then
		PositionEntity plchkp, EntityX(w\piv), EntityY(w\piv), EntityZ(w\piv)
		RotateEntity plchkp, 0, EntityYaw(w\piv), 0
	EndIf
Next
For i = 1 To 5
	MoveEntity water(i), .2*i Mod 3-.4, 0, .2*(i+1) Mod 3-.4
Next
		UpdateWorld
		RenderWorld
		WaitTimer timer
		Flip
	Wend					;### Ende der Hauptschleife ###
	Return pos
End Function

Function camfollow(cam, mesh, speed#)
	If EntityY(mesh)>-30 Then	;Falls sich das Modell ber Wasser befindet, dann
		PositionEntity cam, EntityX(mesh), EntityY(mesh), EntityZ(mesh)
									;positioniere die Kamera in dem Modell
		RotateEntity cam, EntityPitch(mesh)+30+speed, EntityYaw(mesh), 0
									;drehe es in die Richtung, in die es schaut und drehe
									;die Kamera ein wenig nach unten, damit man das Auto
									;von schrg oben sieht.
		speed=speed+1
		If speed<.1 Then speed=.1
		MoveEntity cam, 0, 0, -5-2*speed ;Und dann bewege die Kamera je nach Geschwindigkeit
									;des Fahrzeugs ein Stck nach hinten.
	Else						;Falls sich das Modell unter Wasser befindet, belasse die Kamera
		PointEntity cam, mesh	;wo sie ist und schau dem Modell hinter her.
								;PointEntity dreht ein Objekt so, dass es auf ein Anderes zeigt.
								;In diesem Fall wird die Kamera auf den Spielerwagen gedreht.
	EndIf
End Function

Function loadmap(path$)
	;Rckstnde von eventuell schon geffneten
	;Maps entfernen
	For w.waypoint = Each waypoint
		FreeEntity w\piv
		Delete  w
	Next
	For c.car = Each car
		FreeEntity c\mesh
		FreeEntity c\lastwaypoint
		Delete c
	Next
	pivnr = 0
	;Lesezugriff auf die Map starten
	in = ReadFile(path$)
	While Not Eof(in)	;Solange das Ende der Datei
						;noch nicht erreicht wurde,
						;wird weiter gelesen.
		rl$ = ReadLine(in)	;Hier wird eine Zeile aus
							;der Datei gelesen, und
							;in einer Variable zur
							;Weiterverarbeitung gespeichert.
		If Left(rl$, 8) = "mapname="	;Left gibt von einem String
										;die angegebene Anzahl Zeichen
										;beginnend von Links zurck
										;Wenn also die ersten 8 Zeichen
										;"mapname=" sind, dann wird dieser
										;If-Block ausgelst.
			mapname$ = Mid(rl$, 9)	;Mid gibt von einem String alle Zeichen
									;ab der angegebenen Stelle zurck.
									;In diesem Fall werden alle Zeichen
									;ab Inklusive dem 9. zurck gegeben.
		ElseIf Left(rl$, 5) = "hmap="
			terrain = LoadTerrain(Mid(rl$,6))	;Die in der Mapdatei
												;angegebene Heightmap wird geladen.
		ElseIf Left(rl$, 6) = "track="
			tex2 = LoadTexture(Mid(rl$,7))		;Die in der Mapdatei angegebene
												;Strecke wird als Textur geladen.
		ElseIf Left(rl$, 9) = "tracktex="
			tex3 = LoadTexture(Mid(rl$,10))		;Die in der Mapdatei angegebene
												;Straentextur wird geladen.
		ElseIf Left(rl$, 10) = "groundtex="
			tex1 = LoadTexture(Mid(rl$,11))		;Die in der Mapdatei angegebene
												;Bodentextur wird geladen.
		ElseIf Left(rl$, 9) = "startpos="
			c.car = New car						;Ein neues Auto wird erstellt.
			c\npc = 0							;Diesem wird zugewiesen, dass es kein
												;NPC (=Nicht-Spieler-Charakter) ist.
			c\mesh = LoadMesh("car1.x")			;Das Modell des Wagens wird geladen.
			c\maxspeed = 4.5					;Maximalgeschwindigkeit und
			c\turnfact = 1						;Modifikator fr die Lenkgeschwindigkeit
												;werden festgelegt.
			rl$ = Mid(rl$, 10)					;Zwecks einfacher Weiterverarbeitung
												;werden die nun unntigen 9 linken
												;Zeichen abgeschnitten.
			pos = Instr(rl$, ":")				;Die Position des Doppelpunktes im
												;String wird bestimmt
			c\lastwaypoint = CreatePivot()		;Ein Pivot (=Modell ohne sichtbaren
												;Teilen) wird erstellt. Dieses Modell
												;wird spter bentigt.
			PositionEntity c\mesh, Int(Left(rl$,pos)), 1, 64*50-Int(Mid(rl$,pos+1))
												;Das Modell wird an die in der Mapdatei
												;angegebene Startposition versetzt.
			RotateMesh c\mesh, 0, 180, 0		;Das Modell wird abschlieend noch
			ScaleMesh c\mesh, 5, 5, 5			;gedreht und skaliert fr eine bessere
												;Optik im Spiel.
			EntityType c\mesh, 2				;Dem Modell wird ein Kollisionstyp
												;zugewiesen. Dazu spter mehr.
												
		ElseIf Left(rl$, 7) = "npcpos="			;Siehe oben, mit folgenden Ausnahmen:
			c.car = New car
			c\mesh = LoadMesh("car1.x")
			c\maxspeed = 4+Rnd(-.1, -1)			;Zufallswerte fr Maximalgeschwindigkeit
			c\turnfact = Rnd(.9, 1.1)			;und Lenkgeschwindigkeit werden gesetzt.
												;Dadurch wird dafr gesorgt, dass nicht
												;alle Computergegner genau gleich fahren.
			
			c\npc = 1							;Die KI wird aktiviert. Dieses Auto
												;wird jetzt vom Computer gesteuert.
			rl$ = Mid(rl$, 8)
			pos = Instr(rl$, ":")
			c\lastwaypoint = CreatePivot()
			RotateMesh c\mesh, 0, 180, 0
			ScaleMesh c\mesh, 5, 5, 5
			PositionEntity c\mesh, Int(Left(rl$,pos)), 1, 64*50-Int(Mid(rl$,pos+1))
			EntityType c\mesh, 2
			
		ElseIf Left(rl$, 9) = "waypoint="
			rl$ = Mid(rl$, 10)
			pos = Instr(rl$, ":")
			w.waypoint = New waypoint			;Ein neuer Wegpunkt wird erstellt.
			w\piv = CreatePivot()				;Dazu wird ein Pivot erstellt.
			chp = LoadMesh("checkpoint.x", w\piv);Damit dieser Wegpunkt fr den Spieler
												;sichtbar ist, wird ein Modell geladen
												;und der Pivot als Parent gesetzt.
												;Dadurch befindet sich das Modell auf der
												;Position des Wegpunktes.
			ScaleMesh(chp, 20, 20, 20)			;Dieses Modell wird dann skaliert.
			
			x = Left(rl$,pos)					;Position und Orientierung des
			rl$ = Mid(rl$,pos+1)				;Wegpunktes wird ausgelesen
			pos = Instr(rl$, "!")				;x und z sind die Koordinaten
			z = Left(rl$,pos)					;und dir ist die Ausrichtung.
			dir = Mid(rl$,pos+1)
			
			PositionEntity w\piv, x, -1, 64*50-z;Der Wegpunkt wird an seine Position
			RotateEntity w\piv, 0, dir, 0		;verschoben und richtig gedreht.
			EntityType chp, 1					;Dem Wegpunkt wird ein Kollisionstyp zugewiesen.
			w\nr = pivnr						;Dem Wegpunkt wird eine Nummer zugewiesen und
			pivnr = pivnr+1						;danach der Wegpunktzhler um 1 erhht.
			
		ElseIf Left(rl$, 5) = "laps="
			laps = Int(Mid(rl$, 6))				;Anzahl der zu fahrenden Runden wird gesetzt.
		EndIf
	Wend
	
	ScaleTexture tex2, 64, 64					;Die Spur-Textur wird skaliert, so dass sie die
												;gleiche Gre hat, wie das Terrain.
	TextureBlend tex1, 3						;Die Texturen werden auf Multitexturing gesetzt.
	TextureBlend tex2, 2						;Dadurch werden mehrere Texturen auf einem Modell
	TextureBlend tex3, 2						;mglich. Das hat den Sinn, dass die Strecke eine
												;andere Textur hat, als der Rest.
	TerrainShading terrain, 1					;Das Terrain wird schattiert. Dadurch wirkt der
												;Boden realistischer.
	EntityTexture terrain, tex1, 0, 2			;Das Terrain wird mit den drei Texturen texturiert.
	EntityTexture terrain, tex2, 0, 1			;Die letzte Zahl gibt die Texturebene an. Pro
	EntityTexture terrain, tex3, 0, 0			;Ebene kann nur eine Textur vorhanden sein.
	ScaleEntity terrain, 50, 100, 50			;Das Terrain wird vergrert und
	EntityType terrain, 1						;ihm wird ein Kollisionstyp zugewiesen.
	PositionEntity terrain, 0, -101, 0			;Das Terrain wird nach unten verschoben, so dass sich
												;seine hchste Stelle auf einer Hhe mit der Kamera
End Function									;befindet.
